
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>zookeeper原理解析-客户端与服务器端交互 / 憋错料</title>

    <meta name="description" content="zookeeper原理解析-客户端与服务器端交互 Zookeeper集群中server数量总是确定的,所以集群中的server交互采用比较可靠的bio长连接模型:不同于集群中sever间交互zookeeper客户端其实数量是未知的,为了提高zookeeper并发性能,zookeeper客户端与服务器端交互采用nio模型.下面我们主要来讲讲zookeeper的服务器端与客户端的交互.读者对nio不了解的话不妨抽点时间去了解下,对于一些nio框架如netty,mina再如一些web容器如tomcat,jetty底层都实现一套nio框架,对于实现ni">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">zookeeper原理解析-客户端与服务器端交互</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>Zookeeper集群中server数量总是确定的，所以集群中的server交互采用比较可靠的bio长连接模型；不同于集群中sever间交互zookeeper客户端其实数量是未知的，为了提高zookeeper并发性能，zookeeper客户端与服务器端交互采用nio模型。下面我们主要来讲讲zookeeper的服务器端与客户端的交互。读者对nio不了解的话不妨抽点时间去了解下，对于一些nio框架如netty，mina再如一些web容器如tomcat，jetty底层都实现一套nio框架，对于实现nio框架模型大家不妨去谷歌百度搜一下Doug Lea的scalable io in&nbsp;<a href="http://lib.csdn.net/base/javase" rel="external nofollow noreferrer">Java</a>&nbsp;这个ppt。</p>
<p>客户端</p>
<p>ClientCnxnSocketNIO是zookeeper的nio通讯层的客户端部分，下面伪代码示例其核心代码：</p>
<p>ClientCnxnSocketNIO{</p>
<p>doTransport() {</p>
<p>if （如果之前连接没有立马连上，则在这里处理OP_CONNECT事件) {</p>
<p>sendThread.primeConnection();</p>
<p>} else {</p>
<p>doIO</p>
<p>}</p>
<p>//队列中有发送的消息， 开启写</p>
<p>}</p>
<p>doIO() {</p>
<p>if (sockKey.isReadable()) {</p>
<p>sendThread.readResponse(incomingBuffer);</p>
<p>updateLastHeard();</p>
<p>}</p>
<p>if（sockKey.isWritable()） {</p>
<p>Packetp = outgoingQueue.getFirst() //从发送队列取</p>
<p>updateLastSend</p>
<p>p.requestHeader.setXid(cnxn.getXid());//设置客户端的xid</p>
<p>序列化</p>
<p>发送</p>
<p>从发送队列删除</p>
<p>加入到pendingQueue队列</p>
<p>}</p>
<p>}</p>
<p>}</p>
<p>ClientCnxn&nbsp;是客户端操作ClientCnxnSocketNIO的工具，维护了发送任务线程SendThread，事件任务线程EventThead, 发送队列OutgoingQueue以及请求消息的等待队列PendingQueue。下面以伪代码来示例其核心代码</p>
<p>ClientCnxn {</p>
<p>outgoingQueue//待向服务器端发送的队列, 客户端提交请求放入这个队列</p>
<p>pendingQueue&nbsp;//发送以后等待响应的队列,</p>
<p>submitRequest(){</p>
<p>//client端一个封装成一个packet</p>
<p>outgoingQueue.add(packet);</p>
<p>selector.wakeup();</p>
<p>packet.wait();&nbsp;//如果是同步调用wait，应该反馈后会</p>
<p>}</p>
<p>SendThread {</p>
<p>run() {</p>
<p>1.设置clientCnxnSocket 最后发送时间，最后的心跳时间</p>
<p>2. if(!clientCnxnSocket.isConnected()) {</p>
<p>startConnect（） &nbsp;//主要工作clientCnxnSocket做</p>
<p>} else {</p>
<p>计算下次ping的时间,&nbsp;发送心跳</p>
<p>委托给&nbsp;clientCnxnSocket.doTranspor进行底层的nio传输</p>
<p>}</p>
<p>}</p>
<p>primeConnection(){</p>
<p>//构建ConnectRequest</p>
<p>//组合成通讯层的Packet对象，添加到发送队列，对于ConnectRequest其requestHeader为null</p>
<p>outgoingQueue.addFirst</p>
<p>clientCnxnSocket.enableReadWriteOnly();//确保读写事件都监听</p>
<p>}</p>
<p>readResponse(){</p>
<p>1.先读响应头，先对特殊的xid进行处理</p>
<p>2.&nbsp;packet = pendingQueue.remove() //由于client和server都是单线程处理，多队列处理，所以认为全局有序</p>
<p>3. 反序列化响应体response, 并设置到packet上</p>
<p>4.finishPacket 1）同步notifyAll，结束 2）异步加入到event线程的队列</p>
<p>}</p>
<p>}</p>
<p>EventThread{ //主要支持异步的回调</p>
<p>run() {</p>
<p>}</p>
<p>}</p>
<p>}</p>
<p>大家观察客户端操作类Zookeeper里面的操作类主要分为两个参数不带callback的同步方法和参数带callback的异步方法。</p>
<p>1.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;同步调用方法实现类似Future同步转异步模式实现</p>
<p>1）&nbsp; Client提交请求对象封装成packet对象放入OutgoingQueue队列，并调用packet.wait()阻塞当前线程。</p>
<p>2）&nbsp; 每个Client都只有一个SendThread线程是线性处理OutgoingQueue中的请求消息的,SendThread线程通过ClientCnxnSocketNIO工具顺序从OutgoingQueue队列中取请求消息发送到服务器端，同时将请求packet加入到PendingQueue中</p>
<p>3）&nbsp; ClientCnxnSocketNIO工具接收处理服务器端响应</p>
<p>4）&nbsp; 从PendingQueue队列取出对应的packet，并调packet.notifyAll()唤醒阻塞的线程完成同步调用</p>
<p>2.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;异步调用的总体流程跟同步类似关键区别在于</p>
<p>1）&nbsp;&nbsp;向OutgoingQueue队列提交请求后，不会调用packet.wait()阻塞当前线程，主流程继续执行</p>
<p>2）&nbsp;&nbsp;同同步调用</p>
<p>3）&nbsp;&nbsp;同同步调用</p>
<p>4）&nbsp;&nbsp;从PendingQueue队列取出对应的packet，并调packet.callback方法完成回调处理</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTA1MTgxOTEwMzg5NzI/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2Y1hWb2IyNW5kMlZwWDNwb1lXNXhhWFU9L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p>Zookeeper服务器端</p>
<p>NIOServerCnxnFactory工厂类，zookeeperserver用来启动监听客户端连接，每当有客户端请求连接进来，NIOServerCnxnFactory都会为这个链接构建NIOServerCnxn&nbsp;实例来单独处理与这个客户端的交互</p>
<p>NIOServerCnxn封装了处理读取客户端请求数据与及向客户端响应数据</p>
<p>下面通过伪代码来实例：</p>
<p>NIOServerCnxnFactory &nbsp;{</p>
<p>configure {</p>
<p>绑定端口</p>
<p>作为server监听</p>
<p>注册selectkey 的连接时间</p>
<p>}</p>
<p>run { &nbsp;//起到accept的作用</p>
<p>1.&nbsp;OP_ACCEPT， 将NIOServerCnxn(handler)&nbsp;attach到selectkey以便被读写事件使用</p>
<p>2.&nbsp;OP_READ 和&nbsp;OP_WRITE取出handler&nbsp;NIOServerCnxn,并调doIo</p>
<p>}</p>
<p>}</p>
<p>NIOServerCnxn {</p>
<p>构造器 {</p>
<p>//设置selectkey对read感兴趣</p>
<p>}</p>
<p>doIo {</p>
<p>if(k.isReadable()) {</p>
<p>1.&nbsp;读前四个字节, 代表请求内容长度，不包括自己的4字节</p>
<p>2. 读取到字节数组中</p>
<p>3. zkServer.processPacket()或者zkServer.processConnectRequest()</p>
<p>}</p>
<p>if(k.isWritable()) {</p>
<p>1.从outgoingBuffers取ByteBuffer</p>
<p>2.发送bytes</p>
<p>}</p>
<p>}</p>
<p>}</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-21 06:43:54 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e6%b2%a1%e6%9c%89/" title="没有">没有</a>, <a href="https://www.biecuoliao.com/tag/%e6%95%b0%e6%8d%ae/" title="数据">数据</a>, <a href="https://www.biecuoliao.com/tag/%e6%89%a7%e8%a1%8c/" title="执行">执行</a>, <a href="https://www.biecuoliao.com/tag/%e4%bd%9c%e7%94%a8/" title="作用">作用</a>, <a href="https://www.biecuoliao.com/tag/%e8%b0%83%e7%94%a8/" title="调用">调用</a>, <a href="https://www.biecuoliao.com/tag/target/" title="target">target</a>, <a href="https://www.biecuoliao.com/tag/tab/" title="tab">tab</a>, <a href="https://www.biecuoliao.com/tag/%e7%90%86%e8%a7%a3/" title="理解">理解</a>, <a href="https://www.biecuoliao.com/tag/fonts/" title="fonts">fonts</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>zookeeper原理解析-客户端与服务器端交互的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xQALz3.html" rel="bookmark">浅析Java web程序之客户端和服务器端交互原理&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载自http://www.cnblogs.com/lys_013/archive/2012/05/05/2484561.html 1. 协议 a. TCP/IP整体构架概述 TCP/IP协议并不完全符合OSI的七层参考模型.传统的开放式系统互连参考模型,是一种通信协议的7层抽象的参考模型,其中每一层执行某一特定任务. 该模型的目的是使各种硬件在相同的层次上相互通信.这7层是:物理层.数据链路层.网路层.传输层.话路层.表示层和应用层.而TCP/IP通讯协议采用 了4层的层级结构,每一层都呼叫它			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MER6ry0.html" rel="bookmark">&lbrack;转&rsqb;HTTP报文接口及客户端和服务器端交互原理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 协议 a. TCP/IP整体构架概述 TCP/IP协议并不完全符合OSI的七层参考模型.传统的开放式系统互连参考模型,是一种通信协议的7层抽象的参考模型,其中每一层执行某一特定任务.该模型的目的是使各种硬件在相同的层次上相互通信.这7层是:物理层.数据链路层.网路层.传输层.话路层.表示层和应用层.而TCP/IP通讯协议采用了4层的层级结构,每一层都呼叫它的下一层所提供的网络来完成自己的需求.这4层分别为: i. 应用层:应用程序间沟通的层,如超文本传送协议(HTTP).简单电子邮件传输(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZVOPJ3.html" rel="bookmark">15&period;zookeeper原理解析-服务器端处理流程之交互图</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				===================斩秋|http://blog.csdn.net/quhongwei_zhanqiu=============== Zookeeper集群中server数量总是确定的,所以集群中的server交互采用比较可靠的bio长连接模型:不同于集群中sever间交互zookeeper客户端其实数量是未知的,为了提高zookeeper并发性能,zookeeper客户端与服务器端交互采用nio模型.下面我们主要来讲讲zookeeper的服务器端与客户端的交互.读者对nio不			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vzLNk3.html" rel="bookmark">封装一个类搞定90&percnt;安卓客户端与服务器端交互</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本实例封装了一个处理安卓客户端与服务器端交互的几个方法,对于中文乱码问题本实例也找到了解决方案.本例可以处理的场景如下: 1.与服务器端交互json数据. 2.Get方式与服务器端交互数据. 3.Post方式与服务器端交互数据. 4.HttpClient方式与服务器端交互数据. 5.上传文件到服务器端. 6.从服务器端下载文件. 7.从服务器端读取文本文件. 实例截图: 本篇文章将实例代码完整贴出,希望以本文作为一个交流的平台,大家集思广益封装出更好的处理类.交流地址: http://blog.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWAQV63.html" rel="bookmark">Request 接收参数乱码原理解析一：服务器端解码原理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				“Server.UrlDecode(Server.UrlEncode(&quot;北京&quot;)) == “北京””,先用UrlEncode编码然后用UrlDecode解码,这条语句永远为true吗?答案是否定的,结果可能与很多人预想的不大一样.本文主要分析这一问题出现的原理,研究下Server.UrlEncode(),Server.UrlDecode(),Request[&quot;xxx&quot;]三个函数与编码方式的关系. 1. 问题出现的情景 网站采用了GB2312编码,在Web.confi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xaqyN3.html" rel="bookmark">zookeeper原理解析-服务器端处理流程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1)处理器链 这部分内容我们主要讲解zookeeper请求在zookeeper server端的处理流程,对于不同角色的zookeeper具有不同的处理流程, ZookeepeerServer的start方法中会调用setupRequestProcessors()来初始化处理器链,它被子类覆写实现. 1.      LeaderZooKeeperServer 看如上代码主要建立了如下的两个处理器流链 (1)    PrepRequestProcessor(线程) =&gt; ProposalReque			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/412EyOM.html" rel="bookmark">13&period;zookeeper原理解析-服务器端处理流程之处理器详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				===================斩秋|http://blog.csdn.net/quhongwei_zhanqiu=============== 各个processor的主要功能 1) PrepRequestProcessor 如名字这个处理器主要功能是对请求进行预处理, 将client向server请求二进制数据反序列化成sever中请求操作. PrepRequestProcessor做为leader的第一个处理器,它的请求数据来源主要来自: (1)    Leader做一个zk服务接收			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmG17X3.html" rel="bookmark">12&period;zookeeper原理解析-服务器端处理流程之处理器链</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				===================斩秋|http://blog.csdn.net/quhongwei_zhanqiu=============== 这部分内容我们主要讲解zookeeper请求在zookeeper server端的处理流程,对于不同角色的zookeeper具有不同的处理流程, ZookeepeerServer的start方法中会调用setupRequestProcessors()来初始化处理器链,它被子类覆写实现. 1.      LeaderZooKeeperServer			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/ME8bVP4.html" rel="bookmark">3&period;zookeeper原理解析-数据存储之TxnLog事务日志</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				=====================================斩秋|http://blog.csdn.net/quhongwei_zhanqiu======================================= 事务日志文件用来记录事物操作,每一个事务操作如添加,删除节点等等,都会在事务日志中记录一条记录,用来在zookeeper异常情况下,通过txnlog和snapshot文件来恢复数据,下面我们来看下txnLog事务日志文件的格式 打开一个事务日志文件看看 一个日志文			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBmRRJ4.html" rel="bookmark" class="title">glance image cache</a>
					<div>
						The Glance Image Cache The Glance API server may be configured to have an optional local image cache ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEoeGK3.html" rel="bookmark" class="title">Android视图状态及重绘流程分析，带你一步步深入了解View&lpar;三&rpar;</a>
					<div>
						转载请注明出处:http://blog.csdn.net/guolin_blog/article/details/17045157 在 前面一篇文章中,我带着大家一起从源码的层面上分析了视图的绘制流程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDREPw3.html" rel="bookmark" class="title">01背包问题的学习（来源：背包九讲）</a>
					<div>
						问题: 有N件物品和一个容量为V的背包.第i件物品的费用是c[i],价值是w[i].求解将哪些物品装入背包可使价值总和最大. 思路: 这是最基础的背包问题,特点是:每种物品仅有一件,可以选择放或不放. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kXapL3.html" rel="bookmark" class="title">点击单个cell高度变化的动画效果</a>
					<div>
						效果 说明 1. 点击单个cell的时候,其展开与缩放动画实现起来是很麻烦的,做过相关需求的朋友一定知道其中的坑 2. 本例子只是提供了一个解决方案,为了简化操作,将cell高度封装到了Model当中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPDwzBM.html" rel="bookmark" class="title">个人作业-Week2：案例分析</a>
					<div>
						截止时间:2016年9月25日24:00. 很多同学有误解,软件工程课是否就是理论课?或者是几个牛人拼命写代码,其他人打酱油的课?要不然就是学习一个程序语言,搞一个职业培训的课? 都不对, 软件工程有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wEWKQM.html" rel="bookmark" class="title">Web自动化测试工具&mdash;&mdash;Selenium</a>
					<div>
						在最近的Web课程设计上我接触到了Selenium这款Web自动化测试工具,它可以通过一系列find_element()方法定位到目标元素,对其发送模拟按键操作,使操作自动化. 首先,使用pip安装S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eyY6v0.html" rel="bookmark" class="title">为PyCharm添加不同解释器</a>
					<div>
						正常大家会使用Python官网的安装包,即Python.由于自己尝试了下IronPython,但打开PyCharm查看配置,发现并没有IronPython的解释器,这个需要自己加进去,如图: &quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RDzvv4.html" rel="bookmark" class="title">2016&sol;8&sol;7第一周作业</a>
					<div>
						1.描述计算机的组成及其功能. 运算器.控制器.存储器.输入设备.输出设备 控制器 控制器是整个计算机系统的控制中心,是整个计算机的中枢神经,它指挥计算机各部分协调地工作,保证计算机按照预先规定的目标 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49Lpw13.html" rel="bookmark" class="title">第十四次会议</a>
					<div>
						会议照片: 项目进展:项目完成 心得体会:体会到了团队合作的重要性 存在问题:问题基本解决					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KvQ8yM.html" rel="bookmark" class="title">20170818</a>
					<div>
						&lt;link href=&quot;../../../../img/Form/bootstrap.css&quot; rel=&quot;stylesheet&quot; type=&quot;t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0b5BAYM.html" rel="bookmark" class="title">python实现爬虫下载美女图片</a>
					<div>
						python实现爬虫下载美女图片 本次爬取的贴吧是百度的美女吧,给广大男同胞们一些激励 在爬取之前需要在浏览器先登录百度贴吧的帐号,各位也可以在代码中使用post提交或者加入cookie 爬行地址:h ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QaEjl4.html" rel="bookmark" class="title">Focussend最新 Ebook：利用关系数据库开展智能化营销新思路</a>
					<div>
						摘要:在电商.金融.旅游等服务领域,有很多邮件营销人员努力创建相关邮件给用户,如果你从事这个行业,你可能认为批量发送是唯一的选择,但是这只是一个神话-- Foccusend任务关系数据库在邮件营销中的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nePPpM.html" rel="bookmark" class="title">回溯法小实例</a>
					<div>
						1.图的m着色问题: 1 /* 2 *问题描述:给定无向连通图G和m种不同的颜色.用这些颜色为图G的各个顶点着色,每个顶点着一种颜色.是否有一种着色法使G中每条边的两个顶点着不同的颜色. 3 * 这个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mool1wM.html" rel="bookmark" class="title">Jmeter Html 报告优化</a>
					<div>
						转载自南风_real博客园:http://www.cnblogs.com/jaychang/p/5881525.html 但是最近在查阅相关资料时,发现基本都是重复一篇文章Jmeter使用笔记之htm ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K7xXY0.html" rel="bookmark" class="title">Knockout&colon; radio选项切换引发click事件的一点总结</a>
					<div>
						1.场景:如下图,当选择定期存款时,输入框右边出现红色的必输项星号,当选择活期存款时,不再出现该星号. 2.思路一:不使用knockout,直接用click事件,就可以实现这个需求,代码如下: &lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBnvYqM.html" rel="bookmark" class="title">ScrollView  &plus; &amp;nbsp&semi; Listview  实现方案优选</a>
					<div>
						一,按 在开发中,最近常遇到这个UI的结构,遇到了不少问题,如下: 1, listview的高度不对 2, 页面闪动,不在最开始的位置 3, 如果listview的item需要改变高度,listvie ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzyEol4.html" rel="bookmark" class="title">一个JAVA程序员成长之路分享</a>
					<div>
						我搞JAVA也有些日子了, 因为我比较贪玩,上进心不那么强, 总是逼不得已为了高薪跳槽才去学习, 所以也没混成什么大牛, 但好在现在也已经成家立业, 小日子过的还算滋润, 起码顶得住一月近万元的吃喝拉 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVKpod0.html" rel="bookmark" class="title">js轮播（qq幻灯片效果）</a>
					<div>
						&lt;!DOCTYPE html&gt;&lt;html&gt;&lt;head&gt;&lt;meta charset=&quot;utf-8&quot;&gt;&lt;meta http-equ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OlVXP4.html" rel="bookmark" class="title">2&period;算法</a>
					<div>
						一.算法的概念 算法是特定问题求解步骤的描述 在计算机中表现为指令的有限序列 算法是独立存在的一种解决问题的方法和思想. 对于算法而言,语言并不重要,重要的是思想,也就是说,算法与具体的编程语言无关  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MD6zmk3.html" rel="bookmark" class="title">js中各种距离clientWidth</a>
					<div>
						由于本人对原生js中各种距离得应用和区分不是很好,特别总结了一下: clientWidth是对象看到的宽度(不含边线,即border)scrollWidth是对象实际内容的宽度(若无padding,那 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
